﻿#Skill 2.2 Plan and implement SDN

#Configure iDNS
$credential = New-Object Microsoft.Windows.Networkcontroller.credentialproperties
$credential.type = “usernamePassword”
$credential.username = “Contoso\DNSAdmin”
$credential.password = “<Plain Text Password>”
New-NetworkControllerCredential -ConnectionUri $uri -Properties $credential -ResourceId “iDnsServer-Credential”

$request = @{}
$request.properties = @{}
$request.properties.zone = "contoso.int"
$request.properties.connections = @()
$connection1 = @{}
$connection1.managementAddressses = @("10.184.108.9")
$connection1.credential = @{"resourceRef"="/credentials/iDnsServer-Credential"}
$connection1.credentialType = "usernamePassword"
$request.properties.connections += $connection1
$connection2 = @{}
$connection2.managementAddressses = @("10.184.108.10")
$connection2.credential = @{"resourceRef"="/credentials/iDnsServer-Credential"}
$connection2.credentialType = "usernamePassword"
$request.properties.connections += $connection2
$body = ConvertTo-Json $request -Depth 100
Invoke-WebRequest -Headers @{"Accept"="application/json"} -ContentType "application/json; charset=UTF-8" -Method "Put" -Uri "$uri/Networking/v1/iDnsServer/configuration" -Body $body -DisableKeepAlive -UseBasicParsing

$regKey1 = “HKLM:\SYSTEM\CurrentControlSet\Services\NcHostAgent\Parameters\Plugins\Vnet\InfraServices\DnsProxyService”
New-ItemProperty -Path $ regKey1 -Name “Port” -Value 53 -PropertyType DWORD
New-ItemProperty -Path $ regKey1 -Name “ProxyPort” -Value 53 -PropertyType DWORD
New-ItemProperty -Path $ regKey1 -Name “IP” -Value “169.254.169.254” -PropertyType String
New-ItemProperty -Path $ regKey1 -Name “MAC” -Value “AA-BB-CC-AA-BB-CC” -PropertyType String
$regKey2 = “HKLM:\SYSTEM\CurrentControlSet\Services\DNSProxy\Parameters”
New-ItemProperty -Path $ regKey2 -Name “Forwarders” -Value “10.184.108.9,10.184.108.10” -PropertyType String

Enable-NetFirewallRule -DisplayGroup “DNS Proxy Service”

Restart-Service nchostagent -Force

Set-Service -Name “DnsProxy” -StartupType Automatic
Restart-Service -Name “DnsProxy” -Force

#Create ACLs
$acl = New-SCPortACL -Name “TENANT_A_VNET1_ACL” -Description “ACL for TENANT A VNET1” -ManagedByNC
New-SCPortACLRule -PortACL $acl -Name “AllowRDPAccess” -Description “Enable RDP Access to VMs” -Type Inbound -Action Allow -Priority 1001 -LocalPortRange 3389
Get-SCVMNetwork -Name "TENANT_A_VNET1" | Set-SCVMNetwork -PortAcl $acl

