﻿#Skill 2.4 Configure SLB

#Configure BGP Peer
Add-BgpPeer -Name MUX01 -LocalIPAddress 10.10.10.1 -PeerIPAddress 10.10.10.4 -LocalASN 65001 -PeerASN 65003 -OperationMode Mixed -PeeringMode Automatic

#Create VIP in PowerShell
$NCServiceName = “NC” # This is the name of the Network Controller Network Service in VMM
$VMNames = @(“VM1”,”VM2”) # Names of VMs hosting service to be load balanced
$VIPAddress = “20.20.20.4” # VIP Address from VIP Pool
$VIPVMNetwork = “Private VIP Network” # Name of VIP VM Network
$VIPTemplateName = “WebTier” # Name of VIP Template you created
$VIPName = “scvmm_20_20_20_4_WebTeir” # Name of VIP
$lb = Get-SCLoadBalancer | ? Service -match $NCServiceName
$vmNetwork = Get-SCVMNetwork -Name $VIPVMNetwork
$vipMembers = @()
$VMNames | % {$vipMembers += (Get-SCVirtualMachine $_).VirtualNetworkAdapters[0];}
$vipTemplate =  Get-SCLoadBalancerVIPTemplate -Name $VIPTemplateName
New-SCLoadBalancerVIP -Name $VIPName -LoadBalancer $lb -IPAddress $VIPAddress -LoadBalanacerVIPTemplate $vipTemplate -FrontEndVMNetwork $vmNetwork -BackEndVirtualNetworkAdapters $vipMembers
