﻿#Skill 2.7  Managed Tenant VNets

#Create UDR
$routetableproperties = New-Object Microsoft.Windows.NetworkController.RouteTableProperties
$route = new-object Microsoft.Windows.NetworkController.Route
$route.ResourceID = "0_0_0_0_0"
$route.properties = new-object Microsoft.Windows.NetworkController.RouteProperties
$route.properties.AddressPrefix = "0.0.0.0/0"
$route.properties.nextHopType = "VirtualAppliance"
$route.properties.nextHopIpAddress = "192.168.1.10"
$routetableproperties.routes += $route
$routetable = New-NetworkControllerRouteTable -ConnectionUri $uri -ResourceId "Tenant1_Route1" -Properties $routetableproperties

$vnet = Get-NetworkControllerVirtualNetwork -ConnectionUri $uri -ResourceId "Tenant1_VNet1"
$vnet.properties.subnets[0].properties.RouteTable = $routetable
New-networkcontrollervirtualnetwork -connectionuri $uri -properties $vnet.properties -resourceId $vnet.resourceid

#Create Service Insertion Rule
$dstNic = Get-NetworkControllerNetworkInterface -ConnectionUri $uri -ResourceId "Appliance_Ethernet1"
$portmirror = New-Object Microsoft.Windows.NetworkController. ServiceInsertionProperties
$portMirror.Priority = 1

$rule = new-object Microsoft.Windows.NetworkController.ServiceInsertionRule
$rule.ResourceId = “Tenant1_Rule1”
$rule.properties = New-Object Microsoft.Windows.NetworkController.ServiceInsertionRuleProperties
$rule.properties.Description = "Port Mirror Rule"
$rule.properties.Protocol = "All"
$rule.properties.SourcePortRangeStart = "0"
$rule.properties.SourcePortRangeEnd = "65535"
$rule.properties.DestinationPortRangeStart = "0"
$rule.properties.DestinationPortRangeEnd = "65535"
$rule.properties.SourceSubnets = "*"
$rule.properties.DestinationSubnets = "*"
$portmirror.ServiceInsertionRules += $rule

$element = New-Object Microsoft.Windows.NetworkController.ServiceInsertionElement
$element.ResourceId = “Tenant1_Element1”
$element.properties = New-Object Microsoft.Windows.NetworkController.ServiceInsertionElementProperties
$element.properties.Description = "Port Mirror Element"
$element.properties.NetworkInterface = $dstNic
$element.properties.Order = 1
$portmirror.ServiceInsertionElements += $element

$portMirror = New-NetworkControllerServiceInsertion -ConnectionUri $uri -Properties $portmirror -ResourceId "MirrorAll"

$srcNic = get-networkcontrollernetworkinterface -ConnectionUri $uri -ResourceId "MyVM_Ethernet1"
$srcNic.Properties.IpConfigurations[0].Properties.ServiceInsertion = $portMirror
$srcNic = New-NetworkControllerNetworkInterface -ConnectionUri $uri -Properties $srcNic.Properties -ResourceId $srcNic.ResourceId

#Connect Containers to VNet
$vmNic = Get-NetworkControllerNetworkInterface -ConnectionUri $uri -ResourceId "ContainerHost_Ethernet1"
$vmSubnet = Get-NetworkControllerVirtualSubnet -ConnectionUri $uri -ResourceId "Tenant1_VNet1_Subnet1"
$ipconfig = New-Object Microsoft.Windows.NetworkController.NetworkInterfaceIpConfiguration
foreach ($i in 4..10) {
  $ipconfig.ResourceId = “Tenant1_192_168_1_$i”
  $ipconfig.properties = New-Object Microsoft.Windows.NetworkController.NetworkInterfaceIpConfigurationProperties
  $ipconfig.properties.PrivateIPAddress = “192.168.1.$i”
  $ipconfig.properties.PrivateIPAllocationMethod = “Static”
  $ipconfig.properties.Subnet = New-Object Microsoft.Windows.NetworkController.Subnet
  $ipconfig.properties.Subnet.ResourceRef = $vmSubnet.ResourceRef
  $vmnic.properties.IpConfigurations += $ipconfig
}
New-NetworkControllerNetworkInterface -ConnectionUri $uri -ResourceId $vmnic.ResourceId -Properties $vmnic.Properties

docker network create -d l2bridge –subnet=”192.168.1.0/24” –gateway=”192.168.1.1” MyContainerOverlayNetwork
docker run it –network=MyContainerOverlayNetwork <image> <cmd>
